package de.uulm.in.vs.vns.p1a;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.concurrent.ThreadLocalRandom;
/*
 * 
 * Implementieren Sie eine Klasse NumberGuessingGameRequestHandler im Paket de.uulm.in.vs.vns.p1a welche die Spiellogik des Single-Threaded Servers aus der Übung enthält. 
 * Darüber hinaus soll die Klasse aber als neuer Thread ausführbar sein, dafür muss sie das Interface Runnable implementieren.
 * Implementieren Sie eine Klasse NumberGuessingGameThreadedServer im Paket de.uulm.in.vs.vns.p1a, die nach einem Verbindungsaufbau einen neuen Spielprozess (Thread) startet. Verwenden Sie dazu die Java Thread-Klasse.
 * Um den Server vor einer Überlastung durch zu viele Verbindungen zu schützen, begrenzen Sie die maximale Anzahl von gleichzeitig laufenden Spielprozessen auf 4. 
 * Erweitern Sie dafür die Klasse NumberGuessingGameThreadedServer um einen Threadpool durch Verwendung der Klassen ExecutorService bzw. Executor. Kommentieren Sie Ihre ursprüngliche Lösung ohne Threadpool aus, statt diese zu löschen.
 * (Hinweis: Die Klasse NumberGuessingGameRequestHandler muss für diese Aufgabe nicht mehr verändert werden.)
 * 
 */

public class NumberGuessingGameRequestHandler implements Runnable {
    private final Socket connectionSocket;

    public NumberGuessingGameRequestHandler(Socket socket) {
        this.connectionSocket = socket;
    }

    @Override
    public void run() {
        try (BufferedReader reader = new BufferedReader(
                new InputStreamReader(connectionSocket.getInputStream()));
             PrintWriter writer = new PrintWriter(
                new OutputStreamWriter(connectionSocket.getOutputStream()))) {

            writer.println("hey client, guess my secret number!");
            writer.flush();

            int secret = ThreadLocalRandom.current().nextInt(50) + 1;
            int tries = 6;

            String input;
            while ((input = reader.readLine()) != null) {
                try {
                    int guess = Integer.parseInt(input);
                    if (guess == secret) {
                        writer.println("you've won");
                        break;
                    } else if (guess > secret) {
                        writer.println("your guess is too high");
                    } else {
                        writer.println("your guess is too low");
                    }
                    tries -= 1;
                    if (tries == 0) {
                        writer.println("You lose!");
                        break;
                    }
                } catch (NumberFormatException e) {
                    writer.println("Please enter a valid number!");
                } finally {
                    writer.flush();
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}



