package de.uulm.in.vs.vns.p1a;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class NumberGuessingGameThreadedServer {
    public static void main(String[] args) throws IOException {
        
        // Erzeugen eines ExecutorService mit einem Threadpool von 4 Threads
        ExecutorService threadPool = Executors.newFixedThreadPool(4); // Alternative .newCachedThreadPool();

        try (ServerSocket serverSocket = new ServerSocket(5555)) {
            while (true) {
                System.out.println("waiting for connection");
                Socket connectionSocket = serverSocket.accept();
                System.out.println("connection accepted");

                // ExecutorService, um die Anfrage zu bearbeiten
                threadPool.execute(new NumberGuessingGameRequestHandler(connectionSocket));

                /* 
                / SOLUTION: Ohne Threadpool
                Thread thread = new Thread(new NumberGuessingGameRequestHandler(connectionSocket));
                thread.start();
                */
            }
        } finally {
            threadPool.shutdown();  // Wichtig, um den ExecutorService ordnungsgemäß herunterzufahren
        }
    }
}
